(require #:parenscript-series)

(defpackage #:parenscript-series-tests
  (:use #:cl #:parenscript-series))

;; Custom JavaScript-centric scanners and collectors

(ps*-series
  '(collect-js-array-push
     (series:map-fn T (lambda (x) (* x 2))
       (series:map-fn T #'1+
         (scan-js-array '(1 2 3))))))
;; => #<JavaScript code>
;; => [4, 6, 8] // when evaluated with JavaScript

(ps*-series
  '(collect-js-array-unshift
     (series:map-fn T (lambda (x) (* x 2))
       (series:map-fn T #'1+
         (scan-js-array '(1 2 3))))))
;; => #<JavaScript code>
;; => [8, 6, 4] // when evaluated with JavaScript



(ps*-series
  '(collect-js-array-push
     (series:map-fn T (lambda (x) (* x 2))
       (series:map-fn T #'1+
         (scan-js-array-reverse '(1 2 3))))))
;; => #<JavaScript code>
;; => [8, 6, 4] // when evaluated with JavaScript

(ps*-series
  '(collect-js-array-unshift
     (series:map-fn T (lambda (x) (* x 2))
       (series:map-fn T #'1+
         (scan-js-array-reverse '(1 2 3))))))
;; => #<JavaScript code>
;; => [4, 6, 8] // when evaluated with JavaScript



(parenscript-series:ps*-series
  '(parenscript-series:collect-js-array-push
     (series:map-fn T #'1+
       (parenscript-series:scan-js-array '(1 2 3)))))

(parenscript-series:ps*-series
  '(parenscript-series:collect-js-array-unshift
     (series:map-fn T #'1+
       (parenscript-series:scan-js-array '(1 2 3)))))


(series-expand:series-expand
  '(parenscript-series:collect-js-array-unshift
     (parenscript-series:scan-js-array '(1 2 3))))

(parenscript-series:ps*-series
  '(parenscript-series:collect-js-array-unshift
     (parenscript-series:scan-js-array '(1 2 3))))



;;; Test cases from Waters (1989a)

;;; Test cases from Waters (1989b)
